<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Corporate_Credit_Card_AccountType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper element that includes Corporate Credit Card Account Instance and Data
 * @subpackage Structs
 */
class Corporate_Credit_Card_AccountType extends AbstractStructBase
{
    /**
     * The Corporate_Credit_Card_Account_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the existing Corporate Credit Card Account.
     * - minOccurs: 0
     * @var \StructType\Corporate_Credit_Card_AccountObjectType
     */
    public $Corporate_Credit_Card_Account_Reference;
    /**
     * The Corporate_Credit_Card_Account_Data
     * Meta information extracted from the WSDL
     * - documentation: Corporate Credit Card Account Data.
     * - minOccurs: 0
     * @var \StructType\Corporate_Credit_Card_Account_DataType
     */
    public $Corporate_Credit_Card_Account_Data;
    /**
     * Constructor method for Corporate_Credit_Card_AccountType
     * @uses Corporate_Credit_Card_AccountType::setCorporate_Credit_Card_Account_Reference()
     * @uses Corporate_Credit_Card_AccountType::setCorporate_Credit_Card_Account_Data()
     * @param \StructType\Corporate_Credit_Card_AccountObjectType $corporate_Credit_Card_Account_Reference
     * @param \StructType\Corporate_Credit_Card_Account_DataType $corporate_Credit_Card_Account_Data
     */
    public function __construct(\StructType\Corporate_Credit_Card_AccountObjectType $corporate_Credit_Card_Account_Reference = null, \StructType\Corporate_Credit_Card_Account_DataType $corporate_Credit_Card_Account_Data = null)
    {
        $this
            ->setCorporate_Credit_Card_Account_Reference($corporate_Credit_Card_Account_Reference)
            ->setCorporate_Credit_Card_Account_Data($corporate_Credit_Card_Account_Data);
    }
    /**
     * Get Corporate_Credit_Card_Account_Reference value
     * @return \StructType\Corporate_Credit_Card_AccountObjectType|null
     */
    public function getCorporate_Credit_Card_Account_Reference()
    {
        return $this->Corporate_Credit_Card_Account_Reference;
    }
    /**
     * Set Corporate_Credit_Card_Account_Reference value
     * @param \StructType\Corporate_Credit_Card_AccountObjectType $corporate_Credit_Card_Account_Reference
     * @return \StructType\Corporate_Credit_Card_AccountType
     */
    public function setCorporate_Credit_Card_Account_Reference(\StructType\Corporate_Credit_Card_AccountObjectType $corporate_Credit_Card_Account_Reference = null)
    {
        $this->Corporate_Credit_Card_Account_Reference = $corporate_Credit_Card_Account_Reference;
        return $this;
    }
    /**
     * Get Corporate_Credit_Card_Account_Data value
     * @return \StructType\Corporate_Credit_Card_Account_DataType|null
     */
    public function getCorporate_Credit_Card_Account_Data()
    {
        return $this->Corporate_Credit_Card_Account_Data;
    }
    /**
     * Set Corporate_Credit_Card_Account_Data value
     * @param \StructType\Corporate_Credit_Card_Account_DataType $corporate_Credit_Card_Account_Data
     * @return \StructType\Corporate_Credit_Card_AccountType
     */
    public function setCorporate_Credit_Card_Account_Data(\StructType\Corporate_Credit_Card_Account_DataType $corporate_Credit_Card_Account_Data = null)
    {
        $this->Corporate_Credit_Card_Account_Data = $corporate_Credit_Card_Account_Data;
        return $this;
    }
}
