<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Purchase_Order_Line_Additional_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper element containing the Purchase Order Line additional data for requested references or criteria, and for requested response group
 * @subpackage Structs
 */
class Purchase_Order_Line_Additional_DataType extends AbstractStructBase
{
    /**
     * The Purchase_Order_Line_Additional_Data_Reference
     * Meta information extracted from the WSDL
     * - documentation: The purchase order line reference
     * - minOccurs: 0
     * @var \StructType\Purchase_Order_LineObjectType
     */
    public $Purchase_Order_Line_Additional_Data_Reference;
    /**
     * The Business_Object_Additional_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Business_Object_Additional_Data;
    /**
     * Constructor method for Purchase_Order_Line_Additional_DataType
     * @uses Purchase_Order_Line_Additional_DataType::setPurchase_Order_Line_Additional_Data_Reference()
     * @uses Purchase_Order_Line_Additional_DataType::setBusiness_Object_Additional_Data()
     * @param \StructType\Purchase_Order_LineObjectType $purchase_Order_Line_Additional_Data_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     */
    public function __construct(\StructType\Purchase_Order_LineObjectType $purchase_Order_Line_Additional_Data_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this
            ->setPurchase_Order_Line_Additional_Data_Reference($purchase_Order_Line_Additional_Data_Reference)
            ->setBusiness_Object_Additional_Data($business_Object_Additional_Data);
    }
    /**
     * Get Purchase_Order_Line_Additional_Data_Reference value
     * @return \StructType\Purchase_Order_LineObjectType|null
     */
    public function getPurchase_Order_Line_Additional_Data_Reference()
    {
        return $this->Purchase_Order_Line_Additional_Data_Reference;
    }
    /**
     * Set Purchase_Order_Line_Additional_Data_Reference value
     * @param \StructType\Purchase_Order_LineObjectType $purchase_Order_Line_Additional_Data_Reference
     * @return \StructType\Purchase_Order_Line_Additional_DataType
     */
    public function setPurchase_Order_Line_Additional_Data_Reference(\StructType\Purchase_Order_LineObjectType $purchase_Order_Line_Additional_Data_Reference = null)
    {
        $this->Purchase_Order_Line_Additional_Data_Reference = $purchase_Order_Line_Additional_Data_Reference;
        return $this;
    }
    /**
     * Get Business_Object_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getBusiness_Object_Additional_Data()
    {
        return $this->Business_Object_Additional_Data;
    }
    /**
     * Set Business_Object_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @return \StructType\Purchase_Order_Line_Additional_DataType
     */
    public function setBusiness_Object_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this->Business_Object_Additional_Data = $business_Object_Additional_Data;
        return $this;
    }
}
