<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Company_Asset_Book_Restrictions_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Request on the Company Asset Book Restrictions operation.
 * @subpackage Structs
 */
class Put_Company_Asset_Book_Restrictions_RequestType extends AbstractStructBase
{
    /**
     * The Company_Asset_Book_Restriction_Data
     * Meta information extracted from the WSDL
     * - documentation: Create, update, or delete Company Asset Book Restrictions for specified Company.
     * - minOccurs: 0
     * @var \StructType\Company_Asset_Book_Restrictions_DataType
     */
    public $Company_Asset_Book_Restriction_Data;
    /**
     * The Add_Only
     * Meta information extracted from the WSDL
     * - documentation: Ensure that the request will not delete or modify any existing Company Asset Book Restrictions.
     * @var bool
     */
    public $Add_Only;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Company_Asset_Book_Restrictions_RequestType
     * @uses Put_Company_Asset_Book_Restrictions_RequestType::setCompany_Asset_Book_Restriction_Data()
     * @uses Put_Company_Asset_Book_Restrictions_RequestType::setAdd_Only()
     * @uses Put_Company_Asset_Book_Restrictions_RequestType::setVersion()
     * @param \StructType\Company_Asset_Book_Restrictions_DataType $company_Asset_Book_Restriction_Data
     * @param bool $add_Only
     * @param string $version
     */
    public function __construct(\StructType\Company_Asset_Book_Restrictions_DataType $company_Asset_Book_Restriction_Data = null, $add_Only = null, $version = null)
    {
        $this
            ->setCompany_Asset_Book_Restriction_Data($company_Asset_Book_Restriction_Data)
            ->setAdd_Only($add_Only)
            ->setVersion($version);
    }
    /**
     * Get Company_Asset_Book_Restriction_Data value
     * @return \StructType\Company_Asset_Book_Restrictions_DataType|null
     */
    public function getCompany_Asset_Book_Restriction_Data()
    {
        return $this->Company_Asset_Book_Restriction_Data;
    }
    /**
     * Set Company_Asset_Book_Restriction_Data value
     * @param \StructType\Company_Asset_Book_Restrictions_DataType $company_Asset_Book_Restriction_Data
     * @return \StructType\Put_Company_Asset_Book_Restrictions_RequestType
     */
    public function setCompany_Asset_Book_Restriction_Data(\StructType\Company_Asset_Book_Restrictions_DataType $company_Asset_Book_Restriction_Data = null)
    {
        $this->Company_Asset_Book_Restriction_Data = $company_Asset_Book_Restriction_Data;
        return $this;
    }
    /**
     * Get Add_Only value
     * @return bool|null
     */
    public function getAdd_Only()
    {
        return $this->Add_Only;
    }
    /**
     * Set Add_Only value
     * @param bool $add_Only
     * @return \StructType\Put_Company_Asset_Book_Restrictions_RequestType
     */
    public function setAdd_Only($add_Only = null)
    {
        // validation for constraint: boolean
        if (!is_null($add_Only) && !is_bool($add_Only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($add_Only, true), gettype($add_Only)), __LINE__);
        }
        $this->Add_Only = $add_Only;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Company_Asset_Book_Restrictions_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
