<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Web_Item_Attributes_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Web Item Attributes Request Element
 * @subpackage Structs
 */
class Put_Web_Item_Attributes_RequestType extends AbstractStructBase
{
    /**
     * The Web_Item_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Web Item.
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Web_Item_Reference;
    /**
     * The Web_Item_Attributes_Data
     * @var \StructType\Web_Item_Attributes_DataType
     */
    public $Web_Item_Attributes_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Web_Item_Attributes_RequestType
     * @uses Put_Web_Item_Attributes_RequestType::setWeb_Item_Reference()
     * @uses Put_Web_Item_Attributes_RequestType::setWeb_Item_Attributes_Data()
     * @uses Put_Web_Item_Attributes_RequestType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $web_Item_Reference
     * @param \StructType\Web_Item_Attributes_DataType $web_Item_Attributes_Data
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $web_Item_Reference = null, \StructType\Web_Item_Attributes_DataType $web_Item_Attributes_Data = null, $version = null)
    {
        $this
            ->setWeb_Item_Reference($web_Item_Reference)
            ->setWeb_Item_Attributes_Data($web_Item_Attributes_Data)
            ->setVersion($version);
    }
    /**
     * Get Web_Item_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getWeb_Item_Reference()
    {
        return $this->Web_Item_Reference;
    }
    /**
     * Set Web_Item_Reference value
     * @param \StructType\Unique_IdentifierObjectType $web_Item_Reference
     * @return \StructType\Put_Web_Item_Attributes_RequestType
     */
    public function setWeb_Item_Reference(\StructType\Unique_IdentifierObjectType $web_Item_Reference = null)
    {
        $this->Web_Item_Reference = $web_Item_Reference;
        return $this;
    }
    /**
     * Get Web_Item_Attributes_Data value
     * @return \StructType\Web_Item_Attributes_DataType|null
     */
    public function getWeb_Item_Attributes_Data()
    {
        return $this->Web_Item_Attributes_Data;
    }
    /**
     * Set Web_Item_Attributes_Data value
     * @param \StructType\Web_Item_Attributes_DataType $web_Item_Attributes_Data
     * @return \StructType\Put_Web_Item_Attributes_RequestType
     */
    public function setWeb_Item_Attributes_Data(\StructType\Web_Item_Attributes_DataType $web_Item_Attributes_Data = null)
    {
        $this->Web_Item_Attributes_Data = $web_Item_Attributes_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Web_Item_Attributes_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
