<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Purchase_Order_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Submit Purchase Order Response Data
 * @subpackage Structs
 */
class Submit_Purchase_Order_ResponseType extends AbstractStructBase
{
    /**
     * The Purchase_Order_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Purchase Order
     * - minOccurs: 0
     * @var \StructType\Purchase_OrderObjectType
     */
    public $Purchase_Order_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Purchase_Order_ResponseType
     * @uses Submit_Purchase_Order_ResponseType::setPurchase_Order_Reference()
     * @uses Submit_Purchase_Order_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Purchase_Order_ResponseType::setVersion()
     * @param \StructType\Purchase_OrderObjectType $purchase_Order_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\Purchase_OrderObjectType $purchase_Order_Reference = null, \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null, $version = null)
    {
        $this
            ->setPurchase_Order_Reference($purchase_Order_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Purchase_Order_Reference value
     * @return \StructType\Purchase_OrderObjectType|null
     */
    public function getPurchase_Order_Reference()
    {
        return $this->Purchase_Order_Reference;
    }
    /**
     * Set Purchase_Order_Reference value
     * @param \StructType\Purchase_OrderObjectType $purchase_Order_Reference
     * @return \StructType\Submit_Purchase_Order_ResponseType
     */
    public function setPurchase_Order_Reference(\StructType\Purchase_OrderObjectType $purchase_Order_Reference = null)
    {
        $this->Purchase_Order_Reference = $purchase_Order_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * Set Exceptions_Response_Data value
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @return \StructType\Submit_Purchase_Order_ResponseType
     */
    public function setExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null)
    {
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Purchase_Order_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
