<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Requisition_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Submit Requisition Response Data
 * @subpackage Structs
 */
class Submit_Requisition_ResponseType extends AbstractStructBase
{
    /**
     * The Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Requisition
     * - minOccurs: 0
     * @var \StructType\RequisitionObjectType
     */
    public $Requisition_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Requisition_ResponseType
     * @uses Submit_Requisition_ResponseType::setRequisition_Reference()
     * @uses Submit_Requisition_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Requisition_ResponseType::setVersion()
     * @param \StructType\RequisitionObjectType $requisition_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\RequisitionObjectType $requisition_Reference = null, \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null, $version = null)
    {
        $this
            ->setRequisition_Reference($requisition_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Requisition_Reference value
     * @return \StructType\RequisitionObjectType|null
     */
    public function getRequisition_Reference()
    {
        return $this->Requisition_Reference;
    }
    /**
     * Set Requisition_Reference value
     * @param \StructType\RequisitionObjectType $requisition_Reference
     * @return \StructType\Submit_Requisition_ResponseType
     */
    public function setRequisition_Reference(\StructType\RequisitionObjectType $requisition_Reference = null)
    {
        $this->Requisition_Reference = $requisition_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * Set Exceptions_Response_Data value
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @return \StructType\Submit_Requisition_ResponseType
     */
    public function setExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null)
    {
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Requisition_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
