<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Supplier_Invoice_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Submit Supplier Invoice Response Data
 * @subpackage Structs
 */
class Submit_Supplier_Invoice_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Supplier Invoice
     * - minOccurs: 0
     * @var \StructType\Supplier_InvoiceObjectType
     */
    public $Supplier_Invoice_Reference;
    /**
     * The Supplier_Invoice_Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Supplier Invoice Event
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Supplier_Invoice_Event_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - documentation: Exceptions Response Data
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType[]
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Supplier_Invoice_ResponseType
     * @uses Submit_Supplier_Invoice_ResponseType::setSupplier_Invoice_Reference()
     * @uses Submit_Supplier_Invoice_ResponseType::setSupplier_Invoice_Event_Reference()
     * @uses Submit_Supplier_Invoice_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Supplier_Invoice_ResponseType::setVersion()
     * @param \StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference
     * @param \StructType\Unique_IdentifierObjectType $supplier_Invoice_Event_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType[] $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference = null, \StructType\Unique_IdentifierObjectType $supplier_Invoice_Event_Reference = null, array $exceptions_Response_Data = array(), $version = null)
    {
        $this
            ->setSupplier_Invoice_Reference($supplier_Invoice_Reference)
            ->setSupplier_Invoice_Event_Reference($supplier_Invoice_Event_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Invoice_Reference value
     * @return \StructType\Supplier_InvoiceObjectType|null
     */
    public function getSupplier_Invoice_Reference()
    {
        return $this->Supplier_Invoice_Reference;
    }
    /**
     * Set Supplier_Invoice_Reference value
     * @param \StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference
     * @return \StructType\Submit_Supplier_Invoice_ResponseType
     */
    public function setSupplier_Invoice_Reference(\StructType\Supplier_InvoiceObjectType $supplier_Invoice_Reference = null)
    {
        $this->Supplier_Invoice_Reference = $supplier_Invoice_Reference;
        return $this;
    }
    /**
     * Get Supplier_Invoice_Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getSupplier_Invoice_Event_Reference()
    {
        return $this->Supplier_Invoice_Event_Reference;
    }
    /**
     * Set Supplier_Invoice_Event_Reference value
     * @param \StructType\Unique_IdentifierObjectType $supplier_Invoice_Event_Reference
     * @return \StructType\Submit_Supplier_Invoice_ResponseType
     */
    public function setSupplier_Invoice_Event_Reference(\StructType\Unique_IdentifierObjectType $supplier_Invoice_Event_Reference = null)
    {
        $this->Supplier_Invoice_Event_Reference = $supplier_Invoice_Event_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType[]|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * This method is responsible for validating the values passed to the setExceptions_Response_Data method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExceptions_Response_Data method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExceptions_Response_DataForArrayConstraintsFromSetExceptions_Response_Data(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $submit_Supplier_Invoice_ResponseTypeExceptions_Response_DataItem) {
            // validation for constraint: itemType
            if (!$submit_Supplier_Invoice_ResponseTypeExceptions_Response_DataItem instanceof \StructType\Application_Instance_Related_Exceptions_DataType) {
                $invalidValues[] = is_object($submit_Supplier_Invoice_ResponseTypeExceptions_Response_DataItem) ? get_class($submit_Supplier_Invoice_ResponseTypeExceptions_Response_DataItem) : sprintf('%s(%s)', gettype($submit_Supplier_Invoice_ResponseTypeExceptions_Response_DataItem), var_export($submit_Supplier_Invoice_ResponseTypeExceptions_Response_DataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Exceptions_Response_Data property can only contain items of type \StructType\Application_Instance_Related_Exceptions_DataType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Exceptions_Response_Data value
     * @throws \InvalidArgumentException
     * @param \StructType\Application_Instance_Related_Exceptions_DataType[] $exceptions_Response_Data
     * @return \StructType\Submit_Supplier_Invoice_ResponseType
     */
    public function setExceptions_Response_Data(array $exceptions_Response_Data = array())
    {
        // validation for constraint: array
        if ('' !== ($exceptions_Response_DataArrayErrorMessage = self::validateExceptions_Response_DataForArrayConstraintsFromSetExceptions_Response_Data($exceptions_Response_Data))) {
            throw new \InvalidArgumentException($exceptions_Response_DataArrayErrorMessage, __LINE__);
        }
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Add item to Exceptions_Response_Data value
     * @throws \InvalidArgumentException
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $item
     * @return \StructType\Submit_Supplier_Invoice_ResponseType
     */
    public function addToExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Application_Instance_Related_Exceptions_DataType) {
            throw new \InvalidArgumentException(sprintf('The Exceptions_Response_Data property can only contain items of type \StructType\Application_Instance_Related_Exceptions_DataType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Exceptions_Response_Data[] = $item;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Supplier_Invoice_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
