<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Transfer_Asset_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Response on the Put operation.
 * @subpackage Structs
 */
class Transfer_Asset_ResponseType extends AbstractStructBase
{
    /**
     * The Asset_Transfer_Reference
     * Meta information extracted from the WSDL
     * - documentation: Business Asset specified for Transfer.
     * - minOccurs: 0
     * @var \StructType\Business_AssetObjectType
     */
    public $Asset_Transfer_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Transfer_Asset_ResponseType
     * @uses Transfer_Asset_ResponseType::setAsset_Transfer_Reference()
     * @uses Transfer_Asset_ResponseType::setVersion()
     * @param \StructType\Business_AssetObjectType $asset_Transfer_Reference
     * @param string $version
     */
    public function __construct(\StructType\Business_AssetObjectType $asset_Transfer_Reference = null, $version = null)
    {
        $this
            ->setAsset_Transfer_Reference($asset_Transfer_Reference)
            ->setVersion($version);
    }
    /**
     * Get Asset_Transfer_Reference value
     * @return \StructType\Business_AssetObjectType|null
     */
    public function getAsset_Transfer_Reference()
    {
        return $this->Asset_Transfer_Reference;
    }
    /**
     * Set Asset_Transfer_Reference value
     * @param \StructType\Business_AssetObjectType $asset_Transfer_Reference
     * @return \StructType\Transfer_Asset_ResponseType
     */
    public function setAsset_Transfer_Reference(\StructType\Business_AssetObjectType $asset_Transfer_Reference = null)
    {
        $this->Asset_Transfer_Reference = $asset_Transfer_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Transfer_Asset_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
