<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Travel_ProfileType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing a set of returned travel profiles and a subelement containing their associated data.
 * @subpackage Structs
 */
class Travel_ProfileType extends AbstractStructBase
{
    /**
     * The Travel_Profile_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Worker Travel Profile
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Travel_Profile_Reference;
    /**
     * The Travel_Profile_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Travel_Profile_DataType
     */
    public $Travel_Profile_Data;
    /**
     * Constructor method for Travel_ProfileType
     * @uses Travel_ProfileType::setTravel_Profile_Reference()
     * @uses Travel_ProfileType::setTravel_Profile_Data()
     * @param \StructType\Unique_IdentifierObjectType $travel_Profile_Reference
     * @param \StructType\Travel_Profile_DataType $travel_Profile_Data
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $travel_Profile_Reference = null, \StructType\Travel_Profile_DataType $travel_Profile_Data = null)
    {
        $this
            ->setTravel_Profile_Reference($travel_Profile_Reference)
            ->setTravel_Profile_Data($travel_Profile_Data);
    }
    /**
     * Get Travel_Profile_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getTravel_Profile_Reference()
    {
        return $this->Travel_Profile_Reference;
    }
    /**
     * Set Travel_Profile_Reference value
     * @param \StructType\Unique_IdentifierObjectType $travel_Profile_Reference
     * @return \StructType\Travel_ProfileType
     */
    public function setTravel_Profile_Reference(\StructType\Unique_IdentifierObjectType $travel_Profile_Reference = null)
    {
        $this->Travel_Profile_Reference = $travel_Profile_Reference;
        return $this;
    }
    /**
     * Get Travel_Profile_Data value
     * @return \StructType\Travel_Profile_DataType|null
     */
    public function getTravel_Profile_Data()
    {
        return $this->Travel_Profile_Data;
    }
    /**
     * Set Travel_Profile_Data value
     * @param \StructType\Travel_Profile_DataType $travel_Profile_Data
     * @return \StructType\Travel_ProfileType
     */
    public function setTravel_Profile_Data(\StructType\Travel_Profile_DataType $travel_Profile_Data = null)
    {
        $this->Travel_Profile_Data = $travel_Profile_Data;
        return $this;
    }
}
